unit Prottest;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Tprot_16, StdCtrls, ExtCtrls, Grids,
  DBGrids, Menus, Buttons, About16, Dsgnintf, Treb_16, Gauges;

type
  TForm1 = class(TForm)
    tblWorking: TTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    Button3: TButton;
    Button5: TButton;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenTable1: TMenuItem;
    CloseTable1: TMenuItem;
    N1: TMenuItem;
    ActivatePrimaryIndex1: TMenuItem;
    ActivateSecondaryIndex1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Break1: TMenuItem;
    Tablefiledb1: TMenuItem;
    PrimaryIndex1: TMenuItem;
    SecondaryIndexXG01: TMenuItem;
    Protect1: TMenuItem;
    Button4: TButton;
    Button6: TButton;
    SpeedButton1: TSpeedButton;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    TableFiledb2: TMenuItem;
    PrimaryIndexpx1: TMenuItem;
    SecondaryIndex1: TMenuItem;
    ActivatePrimaryIndex2: TMenuItem;
    ActivateSecondaryIndex2: TMenuItem;
    About1: TMenuItem;
    Button2: TButton;
    SetProperties1: TMenuItem;
    ComponentsProperties1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Rebuilder1: TRebuilder;
    PopupMenu3: TPopupMenu;
    Gauge1: TGauge;
    Label1: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CloseTable1Click(Sender: TObject);
    procedure ActivatePrimaryIndex1Click(Sender: TObject);
    procedure ActivateSecondaryIndex1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Tablefiledb1Click(Sender: TObject);
    procedure PrimaryIndex1Click(Sender: TObject);
    procedure SecondaryIndexXG01Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ComponentsProperties1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Rebuilder1NextTableTest(TestingTableName: String; TableNo,
      TableCount: Integer; IsReb: Boolean);
  private
    { Private declarations }
  public
    procedure ChangeSecondaryIndex(Sender: TObject);

    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
Uses RebProp;
{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
begin
{}
end;

procedure TForm1.Button3Click(Sender: TObject);
var
AliasParams : TstringList;
DosPath : String;
begin
try
  screen.cursor := crHourGlass;
  if Rebuilder1.Protectedalias='' then
    begin
      showmessage('Set please the properties of the TRebuilder first.');
      exit;
    end;
  if tblWorking.active then tblWorking.close;
  AliasParams := TStringList.create;
  Session.GetAliasParams(Rebuilder1.Protectedalias, AliasParams);
  DosPath := (Copy(AliasParams.Strings[0],6,60));
  if (copy(DosPath,length(DosPath)-1,1))<>'\' then DosPath:=DosPath+'\';;
  OpenDialog1.Initialdir := Dospath;
  OpenDialog1.execute;
  tblWorking.DatabaseName := Rebuilder1.Protectedalias;
  tblWorking.TableName := extractFileName(OpenDialog1.FileName);
  tblWorking.open;
finally
  screen.cursor := crDefault;
end;
end;

procedure TForm1.CloseTable1Click(Sender: TObject);
begin
if TblWorking.active then TblWorking.close;
end;

procedure TForm1.ActivatePrimaryIndex1Click(Sender: TObject);
begin
  TblWorking.indexname:='';
DBGRID1.refresh;

end;

procedure TForm1.ActivateSecondaryIndex1Click(Sender: TObject);
var
I        : Integer;
NewItem1 : TMenuItem;
begin
TblWorking.indexdefs.Update;
if TblWorking.indexdefs.count >0 then
  begin
    i:=Popupmenu3.Items.Count;
    if i>0 then
      for i:=0 to(Popupmenu3.Items.Count-1) do
        begin
          Popupmenu3.Items[0].free;
        end;
    for I:=0 to TblWorking.indexdefs.count-1 do
      begin
        NewItem1 := TMenuItem.Create(Popupmenu3);
        NewItem1.Caption :=  TblWorking.indexdefs.items[I].name;
        NewItem1.OnClick := ChangeSecondaryIndex;
        Popupmenu3.Items.add(NewItem1);
        if I=10 then
          NewItem1.Break:=mbBarBreak;
      end;
  end;
PopUpMenu3.popup(Form1.Left+Panel1.Left+10, Form1.top+Panel1.Top+10);
end;

procedure TForm1.ChangeSecondaryIndex(Sender: TObject);
begin
  with sender as TMenuItem do
    begin
      TblWorking.indexname := caption;
      DBGRID1.refresh;
    end;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Tablefiledb1Click(Sender: TObject);
var
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;

begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(TblWorking.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length((DirString)),1)<>'\' then
    DirString := DirString+'\';
  AliasParams.free;
  AliasParams:=nil;
  FileNameStr := DirString + TblWorking.TableName;
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if TblWorking.active then TblWorking.close;
  new(SourceOfStr);
  Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);
  Intres:=_lWrite(Handle,Character,10);
  _lclose(Handle);
  dispose(SourceOfStr);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('     Table is broken!       ');

end;

procedure TForm1.PrimaryIndex1Click(Sender: TObject);
var
Tabname,
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;

begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(TblWorking.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length((DirString)),1)<>'\' then
    DirString := DirString+'\';
  AliasParams.free;
  AliasParams := nil;
  Tabname := copy(TblWorking.TableName,1,pos('.',TblWorking.TableName)-1);
  FileNameStr := DirString + Tabname+'.px';
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if TblWorking.active then TblWorking.close;
  new(SourceOfStr);
  Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);
  Intres:=_lWrite(Handle,Character,10);
  _lclose(Handle);
  dispose(SourceOfStr);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('     Primary index is broken!       ');

end;

procedure TForm1.SecondaryIndexXG01Click(Sender: TObject);
var
Tabname,
DirString,
FileNameStr      : String;

Character,
FileNamePchar    : PChar;

SourceOfStr      : Pofstruct;

IntRes,
Handle           : Integer;

AliasParams      : TstringList;

begin
  AliasParams := TstringList.Create;
  Session.GetAliasParams(TblWorking.DatabaseName, AliasParams);
  DirString := Copy(AliasParams.Strings[0],6,60);
  if copy(DirString,length((DirString)),1)<>'\' then
    DirString := DirString+'\';
  AliasParams.free;
  AliasParams := nil;
  Tabname := copy(TblWorking.TableName,1,pos('.',TblWorking.TableName)-1);
  FileNameStr := DirString + Tabname+'.XG0';
  GetMem(FileNamePchar,length(FileNameStr)+1);
  GetMem(Character,10);
  StrPCopy(Character,'!!!!!!!!!');
  StrPCopy(FileNamePchar,FileNameStr);
  if TblWorking.active then TblWorking.close;
  new(SourceOfStr);
  Handle := OpenFile(FileNamePchar,SourceOfStr^,OF_WRITE);
  Intres:=_lWrite(Handle,Character,10);
  _lclose(Handle);
  dispose(SourceOfStr);
  dispose(Character);
  dispose(FileNamePchar);
  Showmessage('     Secondary index is broken!       ');

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  with sender as TButton do
    begin
      PopUpMenu1.popup(Form1.Left+Panel1.Left+Left, Form1.top+Panel1.Top+Top+3*Height);
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   with sender as TButton do
    begin
      PopUpMenu2.popup(Form1.Left+Panel1.Left+Left, Form1.top+Panel1.Top+Top+3*Height);
    end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.showmodal;
end;

procedure TForm1.ComponentsProperties1Click(Sender: TObject);
begin
   BtnBottomDlg.Showmodal;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
try
  Rebuilder1.checkAlias;
finally
  Gauge1.progress := 0;
  Label1.Caption := 'Finished';
  screen.cursor := crDefault;
end;
end;

procedure TForm1.Rebuilder1NextTableTest(TestingTableName: String; TableNo,
  TableCount: Integer; IsReb: Boolean);
begin
Gauge1.maxvalue := Tablecount;
Gauge1.progress := TableNo;
if Isreb then
  begin
   Label1.Font.Color := clRed;
   Label1.caption := ' Rebuilding table ' + TestingTableName;
  end
else
  Begin
      Label1.Font.Color := clBlack;
   Label1.caption := ' Testing table ' + TestingTableName;
  end;
panel2.refresh;
end;

end.
