unit Rebprop;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, db, ProtTest;

type
  TBtnBottomDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BtnBottomDlg: TBtnBottomDlg;

implementation

{$R *.DFM}

procedure TBtnBottomDlg.FormShow(Sender: TObject);
 Var
 I : Integer;
 AliasNameList: TstringList;
begin
  try
     AliasNameList:= TstringList.create;
     Session.GetAliasNames(AliasNameList);
     for I:=0 to AliasNameList.count-1 do
       begin
         Combobox1.items.add(AliasNameList.strings[i]);
         Combobox2.items.add(AliasNameList.strings[i]);
         Combobox3.items.add(AliasNameList.strings[i]);
       end;
  finally
  AliasNameList.free;
  end;

end;

procedure TBtnBottomDlg.ComboBox3Change(Sender: TObject);
begin
  form1.Rebuilder1.BackUpDataAlias:=Combobox3.Text;
end;

procedure TBtnBottomDlg.ComboBox1Change(Sender: TObject);
begin
  form1.Rebuilder1.ProtectedAlias:=Combobox1.Text;
end;

procedure TBtnBottomDlg.ComboBox2Change(Sender: TObject);
begin
  form1.Rebuilder1.BackUpStrAlias:=Combobox2.Text;
end;

procedure TBtnBottomDlg.Edit1Change(Sender: TObject);
begin
   form1.Rebuilder1.ErrorLogFile:=Edit1.Text;
end;

end.
